function [feat, Permute_Mat] = Fast_Spatial_Pooling(Patch_Stack, grid_list, Permute_Mat)

[sy, sx, sz] = size(Patch_Stack);
if isempty(Permute_Mat)      
    Permute_Mat = zeros(sum(grid_list .^ 2), sx*sy, 'single');
    
    k = 0;
    level = 0;
    for g = grid_list
        level = level + 1;
        
        grid_stops_y = sy / g;
        grid_stops_x = sx / g;
        
        for y = 1:g
            y_stop_true = grid_stops_y * y;
            y_stop = ceil(y_stop_true);
            y_stop(y_stop > sy) = sy;
            
            y_start_true = (y_stop_true - grid_stops_y) + 1;
            y_start = floor(y_start_true);
            
            for x = 1:g
                x_stop_true = grid_stops_x * x;
                x_stop = ceil(x_stop_true);
                x_stop(x_stop > sx) = sx;
                x_start_true = (x_stop_true - grid_stops_x) + 1;
                x_start = floor(x_start_true);
                
                Z = (1 + y_stop-y_start)*(1 + x_stop-x_start);
                
                k = k + 1;
                
                Blank = zeros(sy, sx, 'single');
                Blank(y_start:y_stop, x_start:x_stop) = 1;
                Blank = Blank ./ Z;
                
                Permute_Mat(k, :) = Blank(:);
            end
        end
    end        
end

Patch_Stack = reshape(Patch_Stack, [sx*sy, sz]);
feat = Permute_Mat*Patch_Stack;


